// December 2007 - Remake of some star-holed-pottery posted in 2002
//
// Sorry - today I have no time to translate variable names...
//
// Star punch made in Inkscape
// Bowl and water made in Spilin Editor
//
// Wooden floor by Martial Rameaux (http://pagesperso-orange.fr/cathemline.org/source/jouerenpaix.html)
// flame.inc by Trevor G Quayle (http://news.povray.org/povray.text.scene-files/thread/%3Cweb.4666afce2c74cfc0c150d4c10@news.povray.org%3E/)
// Bowl texture (terracotta) by Alex Kluchikov  (http://news.povray.org/povray.text.scene-files/thread/%3C40a213d1@news.povray.org%3E/?ttop=252441&toff=100)
// Stars2.pov by Jeff (http://news.povray.org/povray.general/message/%3Cweb.41a5a9ad89fd27df699939e0%40news.povray.org%3E/#%3Cweb.41a5a9ad89fd27df699939e0%40news.povray.org%3E)

// More improvment possible (stopped by lack of time):
// ToDo: better pottery texture
// ToDo: caustic
// ToDo: blur?
// ToDo: other floor texture?
// ToDo: floor wood with Warp tutorial
// ToDo: try with isowood


//#include "colors.inc"
#include "flame.inc"
#include "stars2.inc"

#declare Radiosity=on;
#declare ort=0;

global_settings {
  assumed_gamma 1.0
  //max_trace_level 25
  #if (Radiosity)
    radiosity {
      pretrace_start 0.08           // start pretrace at this size
      pretrace_end   0.04           // end pretrace at this size
      count 35                      // higher -> higher quality (1..1600) [35]
      nearest_count 5               // higher -> higher quality (1..10) [5]
      error_bound 1.8               // higher -> smoother, less accurate [1.8]
      recursion_limit 3             // how much interreflections are calculated (1..5+) [3]
      low_error_factor .5           // reduce error_bound during last pretrace step
      gray_threshold 0.0            // increase for weakening colors (0..1) [0]
      minimum_reuse 0.015           // reuse of old radiosity samples [0.015]
      brightness 1                  // brightness of radiosity effects (0..1) [1]

      adc_bailout 0.01/2
      //normal on                   // take surface normals into account [off]
      //media on                    // take media into account [off]
      //save_file "file_name"       // save radiosity data
      //load_file "file_name"       // load saved radiosity data
      //always_sample off           // turn sampling in final trace off [on]
      //max_sample 1.0              // maximum brightness of samples
    }
  #end
}

#default {
  texture {
    pigment {rgb 1}
    #if (Radiosity)
      finish {
        ambient 0.0
        diffuse 0.6
        specular 0.3
      }
    #else
      finish {
        ambient 0.1
        diffuse 0.6
        specular 0.3
      }
    #end
  }
}

// ----------------------------------------

camera {
	#if (ort)
		orthographic
		location 4*y
		location 3*x
		location -10*z
		look_at 0
	#else
		right x*image_width/image_height
		angle 90
		location  <-2,5,-5> 
		look_at   <0,0.5,0>
	#end
}

#if (Radiosity)
	// Soft light
	light_source {
	  <500,500,-500>       // light's position
	  color rgb <0.05, 0.05, 0.45>  // light's color
	  fade_power 2
	}
#else
	light_source {
	  <500,500,-500>       // light's position
	  color rgb <0.05, 0.05, 0.45>  // light's color
	  //color rgb <1, 1, 1>  // light's color
	}
#end

// sky ------------------------------------------------------
sky_sphere {
       pigment{ bozo turbulence 0.76
                        color_map { [0.5  rgbf<0.2,0.2,0.2,1.0> ]
                                    [0.6  rgb <0.2,0.2,0.2>     ]
                                    [0.65 rgb <0.4,0.4,0.4>     ]
                                    [1.0  rgb <0.1,0.1,0.1>     ] }
                       }
}
// ----------------------------------------------------------

// Textures -------------------------------
// The water
#declare c_water = color_map {
	[ 0.00 rgbt <0.4,0.5,0.8, 0.9> ]
	[ 0.90 rgbt <0.4,0.5,0.8, 1> ]
	[ 1.00 rgb <1,1,1> ]
}

#declare t_water = texture {
    pigment{
    //rgbt <0.4,0.5,0.8, 0.9>
    	gradient z 
    	color_map {c_water}
	    turbulence 0.9
    }
    normal {
        ripples 0.75
        frequency 1
        translate <-1,0,1>
    }            
    finish {
		diffuse 0.3
		ambient 0.0
        reflection {0.3, 1 fresnel}
        conserve_energy
		specular 0.4
		roughness 0.003
    }
}
#declare i_water = interior {
    ior 1.33
    fade_distance 0.3
    //fade_power 1001
    //fade_color <0.4, 0.5, 0.47>
}

#declare m_water = material {
    texture {t_water}
    interior {i_water}
}

// LE PLANCHER 
#declare Scl_map=2;
#declare T_Plchmap ="056bois.jpg"
#declare T_PlchBump="056bump.jpg"
#declare Mat_Bois=material{
    texture{pigment{image_map{jpeg T_Plchmap}rotate x*90 scale Scl_map}
	    finish {ambient 0 diffuse 1 specular .1 roughness 0.01 reflection .01}
	    normal{bump_map {jpeg T_PlchBump} bump_size 2.5 scale Scl_map rotate x*90}
    }
}

// terracotta - Alex Kluchikov, 2004
#declare terracotta=texture{
	finish{diffuse 1.3 phong .1}
	normal{
		average normal_map{
		[1,bozo .5 rotate 60 scale .02 noise_generator 3  slope_map{[0,<5,-10>][.5,<0,0>]}]
		[1,bozo .5 rotate 60 scale .015 noise_generator 3 slope_map{[0,<5,-10>][.5,<0,0>]}]
		[1,bozo 2 rotate 60 scale .006 noise_generator 3]
		}scale .75
		}
	pigment{color rgb .5}
}

#declare t_slime=texture{
	pigment{rgb 0.85}//rgb <0.038, 0.033, 0.202>
	finish{
		ambient 0
		conserve_energy
		diffuse 0.4// brilliance 0.52
		reflection{0 1 fresnel on metallic 0}
	}
}

#declare m_auguri=material  {   
	texture {
		pigment{ image_map { png "auguri_en.png" }}
		finish { ambient 0.4 diffuse 0.6}
	}
}


// ----------------------------------------

// Objects --------------------------------
// Bowl - Generated by SpilinEditor v1.2
#declare ciotola_spilin = 
lathe{
	cubic_spline
	20,
	<0.000000,0.029315>,
	<0.000000,0.036644>,
	<0.273608,0.041530>,
	<0.351782,0.002443>,
	<0.508130,0.004886>,
	<0.500801,0.041530>,
	<0.469043,0.068402>,
	<0.500801,0.117261>,
	<0.786624,0.293152>,
	<0.986945,0.657149>,
	<0.938086,0.969844>,
	<0.806168,0.972287>,
	<0.847698,0.857469>,
	<0.881899,0.720665>,
	<0.774410,0.464157>,
	<0.620505,0.315138>,
	<0.437285,0.195435>,
	<0.278494,0.129475>,
	<0.000000,0.112375>,
	<0.041530,0.117261>
}


// Star ---------------------------------
#declare stella_inkscape = prism {
    linear_sweep
    bezier_spline
    1.0, //top
    0.0, //bottom
    40, //nr points
    /*   0*/ <384.24324, 999.99347>, <406.14522, 999.77662>, <461.20472,815.47203>, <478.79634,802.42293>,
    /*   1*/ <478.79634, 802.42293>, <496.38796, 789.37383>, <688.73951,790.15398>, <695.30136,769.25694>,
    /*   2*/ <695.30136, 769.25694>, <701.86321, 748.3599>, <543.59345,639.04196>, <536.61913,618.27894>,
    /*   3*/ <536.61913, 618.27894>, <529.64481, 597.51593>, <589.82668,414.81981>, <571.98014,402.12158>,
    /*   4*/ <571.98014, 402.12158>, <554.13359, 389.42335>, <401.25801,506.16573>, <379.35602,506.38258>,
    /*   5*/ <379.35602, 506.38258>, <357.45403, 506.59943>, <202.29692,392.90687>, <184.7053,405.95597>,
    /*   6*/ <184.7053, 405.95597>, <167.11368, 419.00507>, <230.90113,600.47377>, <224.33928,621.37081>,
    /*   7*/ <224.33928, 621.37081>, <217.77743, 642.26785>, <61.703192,754.6981>, <68.677515,775.46111>,
    /*   8*/ <68.677515, 775.46111>, <75.651838, 796.22413>, <267.95024,791.63558>, <285.79678,804.33381>,
    /*   9*/ <285.79678, 804.33381>, <303.64332, 817.03204>, <362.34125,1000.2103>, <384.24324,999.99347>
}
#declare path3162_MIN_X    = 68.677515;
#declare path3162_CENTER_X = 381.98944;
#declare path3162_MAX_X    = 695.30136;
#declare path3162_WIDTH    = 626.62385;
#declare path3162_MIN_Y    = 402.12158;
#declare path3162_CENTER_Y = 701.05752;
#declare path3162_MAX_Y    = 999.99347;
#declare path3162_HEIGHT   = 597.87189;

#declare stella=object{stella_inkscape
	translate <-path3162_MIN_X, 0, -path3162_MIN_Y>
	scale <1/path3162_WIDTH, 1, 1/path3162_HEIGHT>
	translate <-0.5,-0.5,-0.5>
}

// Star-holed bowl -----------
#declare stellina=object{stella
	scale 0.45
	rotate 90*z+16*y+10*x 
	translate <0.8,0.5,0>
} 

#declare ciotola=difference {
	object{ciotola_spilin}
	#local i=0;
	#while(i<360)
		object { stellina
			rotate i*y
		} 
		#local i=i+60;
	#end
}

// floating candle -------------------
// calare -> how many is lower the water?
// colore -> color 
#macro cero(calare, colore)
	union {
		// Candle
		cylinder{
			0.65*y 0.75*y 0.3	
			texture{pigment{color colore}} finish {ambient 0}
		}
		// Wick
		cylinder{
			0.70*y 0.85*y 0.005
			texture{pigment{color rgb 0.5}} finish {ambient 0}
		}
		// Flame
		object{Flam(0.2) scale .2 translate 0.9*y}
		// Light
		light_source {0.9*y	color colore}
		translate -calare*y
	}
#end

// Water in the bowl --------------------
// Generated by SpilinEditor v1.2
#declare acqua_spilin = 
lathe{
	cubic_spline
	10,
	<0.000000,0.675183>,
	<0.000000,0.675183>,
	<0.799704,0.675183>,
	<0.998939,0.689019>,
	<0.877184,0.398469>,
	<0.702854,0.229673>,
	<0.495319,0.094083>,
	<0.315454,0.019370>,
	<0.000000,0.000000>,
	<0.047041,0.005534>
	scale 0.85
	translate 0.1*y
}

// Bowl with candle ---------------------
// calare -> how many is lower the water?
// colore -> color 
#macro ciotola_stelle(calare, colore, traslare)
	#if (R(3)>2)
		union {
			object {ciotola
				texture{terracotta}
				//texture{t_slime}
				//color rgb 1
			}
			difference {  
				object{acqua_spilin}
				box {<-1,0.75,-1> <1,0.7-calare,1>}
				material{m_water scale 0.1}
			}
			cero(calare, colore)
			translate traslare
		}
	#end
#end

// Wishes card ---------------------
#declare biglietto = object {
	box {<0,0,0,> <1,1,1>}
	material  {m_auguri}   
	rotate x*90
	scale <2, 0.001, 3>
	rotate -60*x
	translate -4*x-2*z
}

// ----------------------------------------

// Scene ----------------------------------

// Some random...
#declare S=seed(20071225);
#macro R(m)int(rand(S)*m+1)#end


// Stars
object {StarSphere rotate <0,0,30> rotate <-10,0,0>}

// Wood floor
box{<-300,0,-300><600,-.1,1000>
	material{Mat_Bois scale 10 rotate 130*y }
} 

// Bowl
//ciotola_stelle(0.2,rgb <rand(S),rand(S),rand(S)>)

// Bowls
#declare imin=-5;
#declare iMax=10;
#local i=imin;
#while (i<iMax)
	#local j=imin;
	#while (j<iMax)
		ciotola_stelle(0.3*rand(S),rgb <rand(S),rand(S),rand(S)>,<3*i.0,3*j>)
		#local j=j+1;
	#end
	#local i=i+1;
#end

// Card
//box{<-4,0,-2> <-2,0.01,1> rgb 1 rotate -60*x translate 1.73*y-z}
object {biglietto }